/*
CLASS:command_continuation:
*/
#ifndef GABA_DEFINE
struct command_continuation
{
  struct lsh_object super;
  void (*(c))(struct command_continuation *self, struct lsh_object *result);
};
extern struct lsh_class command_continuation_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_continuation_class =
{ STATIC_HEADER,
  0, "command_continuation", sizeof(struct command_continuation),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:command:
*/
#ifndef GABA_DEFINE
struct command
{
  struct lsh_object super;
  void (*(call))(struct command *self, struct lsh_object *arg, struct command_continuation *c, struct exception_handler *e);
};
extern struct lsh_class command_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_class =
{ STATIC_HEADER,
  0, "command", sizeof(struct command),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_simple:command
*/
#ifndef GABA_DEFINE
struct command_simple
{
  struct command super;
  struct lsh_object * (*(call_simple))(struct command_simple *self, struct lsh_object *);
};
extern struct lsh_class command_simple_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class command_simple_class =
{ STATIC_HEADER,
  &command_class, "command_simple", sizeof(struct command_simple),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_frame:command_continuation
*/
#ifndef GABA_DEFINE
struct command_frame
{
  struct command_continuation super;
  struct command_continuation *up;
  struct exception_handler *e;
};
extern struct lsh_class command_frame_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_command_frame_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct command_frame *i = (struct command_frame *) o;
  mark((struct lsh_object *) i->up);
  mark((struct lsh_object *) i->e);
}

struct lsh_class command_frame_class =
{ STATIC_HEADER,
  &command_continuation_class, "command_frame", sizeof(struct command_frame),
  do_command_frame_mark,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:command_context:
*/
#ifndef GABA_DEFINE
struct command_context
{
  struct lsh_object super;
  struct command_continuation *c;
  struct exception_handler *e;
};
extern struct lsh_class command_context_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_command_context_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct command_context *i = (struct command_context *) o;
  mark((struct lsh_object *) i->c);
  mark((struct lsh_object *) i->e);
}

struct lsh_class command_context_class =
{ STATIC_HEADER,
  0, "command_context", sizeof(struct command_context),
  do_command_context_mark,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:catch_command:command_simple
*/
#ifndef GABA_DEFINE
struct catch_command
{
  struct command_simple super;
  UINT32 mask;
  UINT32 value;
  int ignore_value;
};
extern struct lsh_class catch_command_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class catch_command_class =
{ STATIC_HEADER,
  &command_simple_class, "catch_command", sizeof(struct catch_command),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:catch_report_collect:command_simple
*/
#ifndef GABA_DEFINE
struct catch_report_collect
{
  struct command_simple super;
  struct report_exception_info *info;
};
extern struct lsh_class catch_report_collect_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_catch_report_collect_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct catch_report_collect *i = (struct catch_report_collect *) o;
  mark((struct lsh_object *) i->info);
}

struct lsh_class catch_report_collect_class =
{ STATIC_HEADER,
  &command_simple_class, "catch_report_collect", sizeof(struct catch_report_collect),
  do_catch_report_collect_mark,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:collect_info_3:
*/
#ifndef GABA_DEFINE
struct collect_info_3
{
  struct lsh_object super;
  struct lsh_object * (*(f))(struct collect_info_3 *self, struct lsh_object *, struct lsh_object *, struct lsh_object *);
};
extern struct lsh_class collect_info_3_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
struct lsh_class collect_info_3_class =
{ STATIC_HEADER,
  0, "collect_info_3", sizeof(struct collect_info_3),
  NULL,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:collect_info_2:
*/
#ifndef GABA_DEFINE
struct collect_info_2
{
  struct lsh_object super;
  struct lsh_object * (*(f))(struct collect_info_2 *self, struct lsh_object *, struct lsh_object *);
  struct collect_info_3 *next;
};
extern struct lsh_class collect_info_2_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_collect_info_2_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct collect_info_2 *i = (struct collect_info_2 *) o;
  mark((struct lsh_object *) i->next);
}

struct lsh_class collect_info_2_class =
{ STATIC_HEADER,
  0, "collect_info_2", sizeof(struct collect_info_2),
  do_collect_info_2_mark,
  NULL
};
#endif /* !GABA_DECLARE */

/*
CLASS:collect_info_1:command_simple
*/
#ifndef GABA_DEFINE
struct collect_info_1
{
  struct command_simple super;
  struct lsh_object * (*(f))(struct collect_info_1 *self, struct lsh_object *);
  struct collect_info_2 *next;
};
extern struct lsh_class collect_info_1_class;
#endif /* !GABA_DEFINE */

#ifndef GABA_DECLARE
static void do_collect_info_1_mark(struct lsh_object *o, 
void (*mark)(struct lsh_object *o))
{
  struct collect_info_1 *i = (struct collect_info_1 *) o;
  mark((struct lsh_object *) i->next);
}

struct lsh_class collect_info_1_class =
{ STATIC_HEADER,
  &command_simple_class, "collect_info_1", sizeof(struct collect_info_1),
  do_collect_info_1_mark,
  NULL
};
#endif /* !GABA_DECLARE */

