TS_TEST_HASH(SHA1, &sha1_algorithm,
	     "abc",
	     #A9993E364706816A BA3E25717850C26C 9CD0D89D#)

/* Test vectors for sha1 from RFC-2202, and some more */

TS_TEST_HMAC(HMAC-SHA1-0, &sha1_algorithm,
	     #0b0b0b0b0b0b0b0b 0b0b0b0b0b0b0b0b#,
	     "Hi There",
	     #675B0B3A1B4DDF4E 124872DA6C2F632B FED957E9#)

TS_TEST_HMAC(HMAC-SHA1-1, &sha1_algorithm,
	     #0b0b0b0b0b0b0b0b 0b0b0b0b0b0b0b0b 0b0b0b0b#,
	     "Hi There",
	     #B617318655057264 E28BC0B6FB378C8E F146BE00#)

TS_TEST_HMAC(HMAC-SHA1-2, &sha1_algorithm,
	     "Jefe",
	     "what do ya want for nothing?",
	     #EFFCDF6AE5EB2FA2 D27416D5F184DF9C 259A7C79#)

TS_TEST_HMAC(HMAC-SHA1-3a, &sha1_algorithm,
	     #AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA#,
	     #DDDDDDDDDDDDDDDD DDDDDDDDDDDDDDDD
	      DDDDDDDDDDDDDDDD DDDDDDDDDDDDDDDD
	      DDDDDDDDDDDDDDDD DDDDDDDDDDDDDDDD
	      DDDD#,
	     #D730594D167E35D5 956FD8003D0DB3D3 F46DC7BB#)

TS_TEST_HMAC(HMAC-SHA1-3, &sha1_algorithm,
	     #AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA AAAAAAAA#,
	     #DDDDDDDDDDDDDDDD DDDDDDDDDDDDDDDD
	      DDDDDDDDDDDDDDDD DDDDDDDDDDDDDDDD
	      DDDDDDDDDDDDDDDD DDDDDDDDDDDDDDDD
	      DDDD#,
	     #125D7342B9AC11CD 91A39AF48AA17B4F 63F175D3#)

TS_TEST_HMAC(HMAC-SHA1-4, &sha1_algorithm,
	     #0102030405060708 090A0B0C0D0E0F10 1112131415161718 19#,
	     #CDCDCDCDCDCDCDCD CDCDCDCDCDCDCDCD
	      CDCDCDCDCDCDCDCD CDCDCDCDCDCDCDCD
	      CDCDCDCDCDCDCDCD CDCDCDCDCDCDCDCD
	      CDCD#,
	     #4C9007F4026250C6 BC8414F9BF50C86C 2D7235DA#)

TS_TEST_HMAC(HMAC-SHA1-5, &sha1_algorithm,
	     #0C0C0C0C0C0C0C0C 0C0C0C0C0C0C0C0C 0C0C0C0C#,
	     "Test With Truncation",
	     #4C1A03424B55E07F E7F27BE1D58BB932 4A9A5A04#)

TS_TEST_HMAC(HMAC-SHA1-6, &sha1_algorithm,
	     #AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA#,
	     "Test Using Larger Than Block-Size Key - Hash Key First",
	     #AA4AE5E15272D00E 95705637CE8A3B55 ED402112#)

TS_TEST_HMAC(HMAC-SHA1-7, &sha1_algorithm,
	     #AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA
              AAAAAAAAAAAAAAAA AAAAAAAAAAAAAAAA#,
	     "Test Using Larger Than Block-Size Key an"
             "d Larger Than One Block-Size Data",
	     #E8E99D0F45237D78 6D6BBAA7965C7808 BBFF1A91#)

